/*
******************************************************************************

   LibBuf implementation for "stubs" target -- Initialization.

   
  
   Copyright (c) Wed Aug 29 2001 by: 
	Brian S. Julin		bri@tull.umassp.edu

  
   
This software may be redistributed under the terms of the GNU Library
(a.k.a. "Lesser") Public License -- see the file COPYING in the parent 
directory of the source code.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.




******************************************************************************
*/

#include "stubsbuf.h"

static int GGIopen(ggi_visual *vis, struct ggi_dlhandle *dlh,
		   const char *args, void *argptr, uint32 *dlret)
{

	/*-* Initialize target-private data structure */

	/*-* Hook in target functions */

	LIBGGI_BUFEXT(vis)->_tie   = BUF_Stubs_ggiBuf_tie;
	LIBGGI_BUFEXT(vis)->_untie = BUF_Stubs_ggiBuf_untie;
	LIBGGI_BUFEXT(vis)->strip  = BUF_Stubs_ggiBufStrip;
	LIBGGI_BUFEXT(vis)->_clad  = BUF_Stubs_ggiBuf_clad;

	vis->opdisplay->getapi = BUF_Stubs_getapi;

        /*-* Apply initial values */

	*dlret = GGI_DL_EXTENSION;
	return 0;
}

static int GGIclose(ggi_visual *vis, struct ggi_dlhandle *dlh)
{

	/*-* Free target-private structure */

	return 0;
}

int BUFdl_stubs_buf(int func, void **funcptr)
{
      switch (func) {
      case GGIFUNC_open:
	*funcptr = GGIopen;
	return 0;
      case GGIFUNC_exit:
	*funcptr = NULL;
	return 0;
      case GGIFUNC_close:
	*funcptr = GGIclose;
	return 0;
      default:
	*funcptr = NULL;
      }
      
      return GGI_ENOTFOUND;
}

/* This should be included by exactly _one_ file in each sublib. */
#include <ggi/internal/ggidlinit.h>
